﻿using System;
using System.Diagnostics;
using System.Linq;
using AsyncClientApp.AsyncServiceReference;

namespace AsyncClientApp
{
    class Program
    {
        static void Main(string[] args)
        {
            int accountId = 1;
            var orderItems = Enumerable.Range(1, 100)
                .Select(x => new OrderItem { ItemId = x, Quantity = x % 5 })
                .ToArray();
            using (var client = new AsyncServiceClient())
            {
                Console.Write("Warming up the sync method...");
                for (int i = 0; i < 3; i++)
                {
                    client.CalculateOrderCostSync(accountId, orderItems);
                }

                Console.WriteLine("running...");
                var sw = Stopwatch.StartNew();
                client.CalculateOrderCostSync(accountId, orderItems);
                Console.WriteLine("    Completed in {0}ms", sw.ElapsedMilliseconds);
                Console.WriteLine();

                Console.Write("Warming up the async method...");
                for (int i = 0; i < 3; i++)
                {
                    client.CalculateOrderCost(accountId, orderItems);
                }

                Console.WriteLine("running...");
                sw.Restart();
                client.CalculateOrderCost(accountId, orderItems);
                Console.WriteLine("    Completed in {0}ms", sw.ElapsedMilliseconds);

                Console.WriteLine();
            }

        }
    }
}
