﻿using System.Collections.Generic;
using System.Threading.Tasks;
using AsyncWcfService.BusinessLogic;
using AsyncWcfService.Entities;

namespace AsyncWcfService
{
    public class AsyncService : IAsyncService
    {
        public readonly SyncBusinessLogic _syncBusinessLogic = new SyncBusinessLogic();
        public readonly AsyncBusinessLogic _asyncBusinessLogic = new AsyncBusinessLogic();

        public decimal CalculateOrderCostSync(int accountId, List<OrderItem> orderItems)
        {
            return _syncBusinessLogic.CalculateOrderCost(accountId, orderItems);
        }

        public async Task<decimal> CalculateOrderCostAsync(int accountId, List<OrderItem> orderItems)
        {
            return await _asyncBusinessLogic.CalculateOrderCostAsync(accountId, orderItems);
        }
    }
}
